module Env where

import AbsSyntax
import Exception

lookupC :: Ctxt -> Int -> E Exp
lookupC [] n = errorE ("lookupC: " ++ show n)
lookupC ((m,e):ctxt) n = if m == n then (return e) else lookupC ctxt n



lookupEnv :: Env -> Name -> E Exp
lookupEnv = lookupDefs . defsOfEnv

delLastDefEnv (Env []) = Env []
delLastDefEnv (Env (d:dfs)) = Env dfs

getConsDefE (Env dfs) = getConsDef dfs
getAllDefEnv (Env dfs) = getAllDef dfs


lookupDefs [] n = errorE ("lookupDefs: " ++ n ++ " not found")
lookupDefs (df:dfs) n = 
   if (nameOfDef df) == n 
   then (return (typeOfDef df))
   else lookupDefs dfs n

getConsDef :: [Def] -> Name -> E Disc
getConsDef [] n = errorE ("getConsDef: " ++ n ++ " is not in environment")
getConsDef (df:dfs) n =
   if (nameOfDef df) == n
   then return (getDef df)
   else getConsDef dfs n

getAllDef :: [Def] -> Name -> E Def
getAllDef [] n = errorE ("getAllDef: " ++ n ++ " is not in environment")
getAllDef (df:dfs) n =
   if (nameOfDef df) == n
   then return df
   else getAllDef dfs n
       
