module Lex (lexanal,TOKEN(..),Pos(..),eot,eotPos,PosTOKEN(..),string_of_token,is_ph,num_of_string,ismyAlphanum) where

-- a simpl lexical analyser

--import Prelude
import Char 

--ord = fromEnum :: (Char->Int)

data TOKEN = Iden String | Symbol String deriving (Eq,Show)

type Pos = (Int,Int)
type PosTOKEN = (Pos,TOKEN)

type PosString = [(Pos,Char)]

string_of_token :: TOKEN -> String
string_of_token (Iden s) = s
string_of_token (Symbol s) = s

sym :: String -> TOKEN
sym = Symbol

eotPos = (999999,999999)::Pos -- ehum...
eot = (eotPos,sym "EOT")

layout :: Char -> Bool
layout x = elem x "\n \t@" || x == '!' 

keyword :: String -> Bool
keyword x = 
 elem x ["case","let","letrec","Set",
         "Theory","Type", "Kind","data","sig","struct","theory","in","of",
	 "decl","#include","rec","cons","fst","snd","use"]

symbolchar :: Char -> Bool
symbolchar x = elem x ":;,{}[]()=<>.\\#%"


keycheck :: String -> TOKEN
keycheck s = if keyword s then Symbol s else Iden s


lexanal = tokenize . addPositions

addPositions s = [((row,column),c) | (row,line) <- zip [1..] (lines s),
                                     (column,c) <- zip [0..] ('\n':line)]
				     -- minor bug: prepends '\n'
				     -- (simple fix for the fact that lines
				     -- removes the '\n' between lines.)

tokenize :: PosString -> [PosTOKEN]
tokenize [] = [eot]
tokenize ((p,'-'):(_,'>'):rest) = (p,sym"->"):(tokenize rest)
tokenize ((p,'|'):(_,'-'):rest) = (p,sym"|-"):(tokenize rest)
tokenize ((p,'%'):(_,'-'):rest) = getcomment 1 rest
tokenize ((p,'"'):rest) = getstring p [] rest
tokenize ((p,a):rest) | layout a = tokenize rest
                      | symbolchar a = (p,sym [a]):(tokenize rest)
		      | otherwise = getword p [a] rest

skipgoal :: PosString -> PosString
skipgoal [] = []
skipgoal ((_,']'):rest) = rest
skipgoal (_:rest) = skipgoal rest

getcomment :: Int -> PosString -> [PosTOKEN] 
getcomment _ [] = [eot]                 -- error??
getcomment n  ((p,'%'):(_,'-'):rest) = getcomment (n+1) rest
getcomment n ((_,'-'):(_,'%'):rest) = 
   (if n==1 then tokenize else getcomment (n-1)) rest
getcomment n (_:rest) = getcomment n rest

ismyAlphanum :: Char -> Bool
ismyAlphanum x = isAlphanum x || x == '_' || x == '$' || x == '#' || x=='\''

getword p s [] = [(p,keycheck s),eot]
getword p s (l@((_,x):rest)) | layout x = (p,keycheck s):tokenize rest
                             | ismyAlphanum x = getword p (s++[x]) rest
			     | otherwise = (p,keycheck s):tokenize l

getstring p s [] = [(p,Iden s),eot]
getstring p s ((_,'"'):rest) = (p,Iden s):(tokenize rest)
getstring p s ((_,x):rest) = getstring p (s++[x]) rest


is_ph :: String -> Bool
is_ph ('?':_) = True
is_ph _ = False

num_of_string :: String -> Int
num_of_string u =
 ns (reverse u)
  where ns [] = 0
        ns (x:xs) = ord x - ord '0' + 10 * (ns xs)

-- For Haskell 1.3
