module ParseCom where

import MyPrelude

import AbsSyntax
import Axioms
import Exception

import MonadSTE
import CheckState
import MonadCheck

import ConvMon
import CheckMon

import Lex
import ParserMonad
import Parser

data FileCom = 
   Load String | LoadF String | PrintEnv 
 | Add Def | DelLast | WhNf Exp | GetDef String | TypeOf String
 | ParseE Exp | ParseD Def 
 | Reset | Help | Quit

readLoad :: [PosTOKEN] -> E FileCom -- we do not need the state now
readLoad = parse readLoadP

readLoadP :: Parse FileCom
readLoadP = 
 do
  cmd <- idenP 
  case cmd of
    "load"     -> return Load `apP` fileNameP
    "loadf"    -> return LoadF `apP` fileNameP
    "env"      -> return PrintEnv
    "add"      -> return Add `apP` defP
    "del"      -> return DelLast
    "whnf"     -> return WhNf `apP` expP
    "getdef"   -> return GetDef `apP` idenP
    "type"     -> return TypeOf `apP` idenP
    "parsexp"  -> return ParseE `apP` expP
    "parsdef"  -> return ParseD `apP` defP
    "reset"    -> return Reset
    "help"     -> return Help
    "quit"     -> return Quit
    _ -> errorP "readLoadP, not a command"

--addComm = Add . filterDef

